--- /usr/share/initramfs-tools/hooks/cryptroot.orig
+++ /usr/share/initramfs-tools/hooks/cryptroot
@@ -301,6 +301,15 @@
 		dev=$(readlink -e "$dev")
 	fi
 
+	if [ "x${dev%/dev/dm-*}" = "x" ]; then
+		# try to detect corresponding symlink in /dev/mapper/
+		for dmdev in /dev/mapper/*; do
+			if [ "$(readlink -e "$dmdev")" = "$dev" ]; then
+				dev="$dmdev"
+			fi
+		done
+	fi
+
 	altdev="${dev#/dev/mapper/}"
 	if [ "$altdev" != "$dev" ]; then
 		echo "$altdev"
